#include <bits/stdc++.h>
#define ll long long
// #define int ll
#define pii pair<int, int>
#define F first
#define S second
#define pb push_back
#define ld long double
#define in insert
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)x.size()
#define deb(x) cout << #x << " = " << x << '\n';
#define file(x) freopen(x".in", "r", stdin), freopen(x".out", "w", stdout)
using namespace std;

// const int dx[] = {0, 1, 0, -1};
// const int dy[] = {1, 0, -1, 0};

const int inf = 1e9;
const ll INF = 1e18;
const int mod = 1e9 + 7;
const int N = 2e5 + 5;

pair <int, int> a[N];
map <int, ld> ans;
map <int, bool> was;
int q[N];

ld p(ld a, int b){
	if (b==0){
		return 1;
	}
	if (b % 2 == 1){
		return p(a, b - 1) * a;
	}
	ld cur = p(a, b / 2);
	return cur * cur;
}

void solve() {
  int n, m;
  cin >> n >> m;
  ld r;
  cin >> r;
  for (int i = 1; i <= n; i++) {
    cin >> a[i].F >> a[i].S;
    was[a[i].F] = 1;
  }
  int temp = n;
  for (int i = 1; i <= m; i++) {
    cin >> q[i];
    if (!was[q[i]]) {
      was[q[i]] = 1;
      a[++temp].F = q[i];
    }
  }
  sort(a + 1, a + temp + 1);
  
  for (int i = 1; i <= temp; i++) {
    ld x = ans[a[i - 1].F] * p((1.0 - r), a[i].F - a[i - 1].F);
    x = x + a[i].S * r;
    ans[a[i].F] = x;
  }
  cout << fixed << setprecision(9);
  for (int i = 1; i <= m; i++) {
    cout << ans[q[i]] << ' ';
  }
}
signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0);
	int TT = 1;
	// cin >> TT;
	while(TT--) {
		solve();
	}
	return 0;
}